#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "cblas.h"

void ATL_szero(const int, float*, const int);

static double time00(void)
{
   struct rusage ruse;
   getrusage(RUSAGE_SELF, &ruse);
   return( (double)(ruse.ru_utime.tv_sec+ruse.ru_utime.tv_usec/1000000.0) );
}

void PrintUsage(char *nam)
{
   fprintf(stderr, "USAGE: %s [N]\n", nam);
}
main(int nargs, char **args)
{
   int N=1000;
   float *A, *B, *C;
   double mf, t0, t1;

   if (nargs > 1) N = atoi(args[1]);
   else N = 1000;

   A = malloc(3*N*N*sizeof(float));
   assert(A);
   B = A + N*N;
   C = B + N*N;
   ATL_szero(N*N*3, A, 1);
   mf = ((2.0*N)*N*N) / 1000000.0;

   while(1)
   {
      t0 = time00();
      cblas_sgemm(CblasColMajor, CblasTrans, CblasNoTrans, N, N, N, 1.0f,
                  A, N, B, N, 0.0f, C, N);
      t1 = time00() - t0;
      printf("time=%f, mflop=%f\n", t1, mf / t1);
   }
   free(A);
   exit(0);
}
